import SimpleOpenNI.*;
import processing.pdf.*;
import fullscreen.*;
FullScreen fullScreen;

HandCapture   handCapture;
boolean       drawFlag=false;
boolean record;

PVector[] matrix;
int anzahl = 25;
int abstand = anzahl *3;
int transformation = 1;

void setup(){
  
    handCapture = new HandCapture(this);
  size(1024,768);
  background(0);
  smooth();
  noCursor();
  matrix = new PVector[anzahl*anzahl];
  
  int i = 0;
    for(int y=0; y<(anzahl*abstand); y+=abstand){
      for(int x=0; x<(anzahl*abstand); x+= abstand){
      matrix[i] = new PVector(x,y,0);
          i++;
    }
  }
  fullScreen = new FullScreen(this);
  fullScreen.enter();

}

void draw(){
  
    handCapture.update();
    
  if (record) {
    beginRecord(PDF, "frame-####.pdf"); 
  }
  if(transformation <=4){
  int anzahl = 25;
  int abstand = anzahl *3;
  }

  if(transformation >=4){
  int anzahl = 50;
  float abstand = anzahl *.5;
  }
  
    background(255);
    PVector handPos = handCapture.handPos();
    PVector mouseVect = new PVector (map(handPos.x,0,640,0,1024), map(handPos.y,0,480,0,768));
    
    for(int i=0; i<(anzahl*anzahl); i++){
      float distValue = PVector.dist(mouseVect, matrix[i]);
      float state;
      
      if(transformation == 1 && transformation == 5){
      state = map(distValue, 0, width*.5, 1, 7);
      state = abs(-state+7);
      if(distValue > width*.5)
      state = 1;
      }
      
      if(transformation == 2 || transformation == 3)
      state = map(distValue, 0, width*0.5, 1, 7);
      
      else
      state = map(distValue, 0, width*sqrt(2), 1, 7);
      

      pushMatrix();
      translate(matrix[i].x,matrix[i].y);
   
      if(mouseVect.x>matrix[i].x)
      rotate(PVector.angleBetween(new PVector (0,-100),PVector.sub(mouseVect,matrix[i])));
      else
      rotate(-PVector.angleBetween(new PVector (0,-100),PVector.sub(mouseVect,matrix[i])));
      
      if(transformation==1){
      float scaleValue;
      scaleValue = map(distValue, 0, width*.5, 1.3, .6);
      if(distValue > width*.5)
      scaleValue = .6;
      scale(scaleValue);
      }
      else
      scale(map(distValue, 0, width*1.41, 1.1, .6));
      
      if(transformation==1)
      form1(state);
      else if(transformation==2)
      form2(state);
      else if(transformation==3)
      form3(state);
      else if(transformation==4)
      form4(state);
      else if(transformation==5)
      form5(state);
      
      popMatrix();
      
    }
    matrixPunkte();
    
    if (record) {
    endRecord();
	record = false;
      }
  }
  
void matrixPunkte(){
  
for(int i=0;i< matrix.length;i++)
  
  {
    point(matrix[i].x,
          matrix[i].y);  
    
  }
}


    
    
void form1(float state){
  
    float i;
    i=state;
    pushMatrix();
    noStroke();

    rotate(radians(-90));
      pushMatrix();
      fill(0);
      popMatrix(); 
      
      pushMatrix(); 
      fill(0);
      ellipse(0,0,map(i,1,7,56,54.67),map(i,1,7,56,54.67));
      popMatrix();
      
      pushMatrix();
      fill(255);
      arc(0.0,0.0,70,70,map(i,1,7,0,radians(-180)),map(i,1,7,0,radians(180)));
      popMatrix();
      
      pushMatrix();
      fill(255);
      ellipse(0,0,40,40);

      popMatrix();
      
     popMatrix();
}

void form2(float state){
  
    float i;
    i=state;
    pushMatrix();
    noStroke();
 
    rotate(radians(-90));
      pushMatrix();
      fill(0);
      popMatrix(); 
      
      pushMatrix(); 
      fill(0);
      ellipse(map(i,1,7,1.5,-2.5),0,map(i,1,7,56,54.67),map(i,1,7,56,54.67));
      popMatrix();
      
      pushMatrix();
      fill(255);
      arc(0.0,0.0,70,70,map(i,1,7,0,radians(-180)),map(i,1,7,0,radians(180)));
      popMatrix();
      
     popMatrix();
  
}

void form3(float state){
  
    float i;
    i=state;
    pushMatrix();
    noStroke();
 
    rotate(radians(-90));
      pushMatrix();
      fill(0);
      popMatrix(); 
      
      pushMatrix(); 
      fill(0);
      ellipse(map(i,1,7,1.5,-2.5),0,map(i,1,7,56,54.67),map(i,1,7,56,54.67));
      popMatrix();
      
      pushMatrix();
      fill(255);
      scale(map(i,1,7,0.8,1.5));
      ellipse(0,0,40,40);

      popMatrix();
      
     popMatrix();
  
  
}


void form4(float state){
  
    float i;
    i=state;
    pushMatrix();
    noStroke();
 
    rotate(radians(-90));
      pushMatrix();
      fill(0);
      rectMode(CENTER);
      rect(0,0,55,5);
      popMatrix(); 
      
      pushMatrix();
      fill(255);
      arc(0.0,0.0,70,70,map(i,1,7,0,radians(-180)),map(i,1,7,0,radians(180)));
      popMatrix();
      
      pushMatrix();
      fill(255);
      scale(map(i,1,7,0.8,1.5));
      popMatrix();
      
     popMatrix();
  
}
    
void form5(float state){
  
    float i;
    i=state;
    pushMatrix();
    noStroke();
 
      pushMatrix();
      fill(0);
      stroke(0);
      line(0,0,0,map(i,1,7,5,50));
      popMatrix();
      
     popMatrix();
  
}
    
void keyPressed()
{
    switch(key)
    {
    case '1':
      transformation = 1;
      break;
      
    case '2':
      transformation = 2;
      break;
      
    case '3':
      transformation = 3;
      break;
      
    case '4':
      transformation = 4;
      break;
      
    case '5':
      transformation = 5;
      break;
      
    case '6':
      transformation = 6;
      break;
      
    case '7':
      transformation = 7;
      break;
      
    case '8':
      transformation = 8;
      break;
      
    case '9':
      transformation = 9;
      break;
      
    case 's':
    record = true;
//      saveFrame("screenShot-###.png");
      println("save the screen to screenShot.bmp");
      break;
    }
}


void onCreateHands(int handId,PVector pos,float time)
{
  handCapture.onCreateHands(handId,pos,time);
}
 
void onUpdateHands(int handId,PVector pos,float time)
{
  handCapture.onUpdateHands(handId,pos,time);
}
 
void onDestroyHands(int handId,float time)
{
  handCapture.onDestroyHands(handId,time);
}
 
void onRecognizeGesture(String strGesture, PVector idPosition, PVector endPosition)
{
  handCapture.onRecognizeGesture(strGesture,idPosition,endPosition);
}
 
void onProgressGesture(String strGesture, PVector position,float progress)
{
  handCapture.onProgressGesture(strGesture,position,progress);
}

class HandCapture
{
  SimpleOpenNI  _context;
  boolean       _drawFlag=false;
  PVector       _handVec = new PVector();
  String        _lastGesture = "";
  PVector       _screenPos = new PVector();
  PApplet       _parent;
  boolean       _handsTrackFlag = false;

  HandCapture(PApplet parent)
  {
    _parent = parent;

    _context = new SimpleOpenNI(_parent);

    // mirror is by default enabled
    _context.setMirror(true);

    // enable depthMap 
    _context.enableDepth();

    // enable camera
    _context.enableRGB();

    _context.enableHands();  
    _context.enableGesture();

    _context.addGesture("RaiseHand");

    // align depth data to image data
    _context.alternativeViewPointDepthToImage();

  }

  boolean isHandTracked() { return _handsTrackFlag; } 
  
  PVector handPos() { return _screenPos; }
  PVector handPos3d() { return _handVec; }
  
  PImage depthImage() { return _context.depthImage(); }
  PImage rgbImage() { return _context.rgbImage(); }
  

  int width() { return _context.depthWidth(); }
  int height() { return _context.depthHeight(); }
  
  void update()
  {
    _context.update();
    
    _context.convertRealWorldToProjective(_handVec,_screenPos);
  }

  void onCreateHands(int handId, PVector pos, float time)
  {
    _handsTrackFlag = true;
    _handVec = pos;
  }

  void onUpdateHands(int handId, PVector pos, float time)
  {
    _handVec = pos;
  }

  void onDestroyHands(int handId, float time)
  {
    _handsTrackFlag = false;
    _context.addGesture(_lastGesture);
  }

  void onRecognizeGesture(String strGesture, PVector idPosition, PVector endPosition)
  {
    _lastGesture = strGesture;
    _context.removeGesture(strGesture); 
    _context.startTrackingHands(endPosition);
  }

  void onProgressGesture(String strGesture, PVector position, float progress)
  {
  }
}

